#include <string>
#include <iostream>
#include <cctype>
#include <vector>

using std::string;
using std::cin;
using std::cout;
using std::endl;
using std::isspace;
using std::vector;

class line
{
	vector<string> cells;
public:
	line(const string &s)
	{
		unsigned a, b=s.size(), c=0;
		bool has = false;
		for(a=0; a<b; ++a)
		{
			if(isspace(s[a]))
			{
				if(has) { cells.push_back(s.substr(c, a-c)); has = false; }
				continue;
			}
			if(!has)
			{
				c = a;
				has = true;
			}
		}
		if(has) cells.push_back(s.substr(c));
	}
	unsigned size() const { return cells.size(); }
	const string &operator[] (unsigned a) const { return cells[a]; }
};

static char nw,n,nm,ne, w,m,e, sw,s,sm,se;

static void SetLineChars(const char *k)
{ nw=k[0]; n=k[1]; nm=k[2]; ne=k[3]; w=k[4]; m=k[5]; e=k[6]; sw=k[7]; s=k[8]; sm=k[9]; se=k[10]; }
static void SetAsciiChars() { SetLineChars("+-++|||+-++"); }
static void SetDOSChars()   { SetLineChars("Ŵ"); }


int main(void)
{
	vector<line> lines;
	vector<unsigned> lengths;
	
	SetAsciiChars();
	//SetDOSChars();
	
	unsigned maxcell=0;
	for(;;)
	{
		string s;
		getline(cin, s);
		if(!cin)break;
		
		line tmp(s);
		if(tmp.size() > maxcell)
		{
			maxcell = tmp.size();
			if(lengths.size() < maxcell) lengths.resize(maxcell);
		}
		for(unsigned a=0; a<tmp.size(); ++a)
			if(tmp[a].size() > lengths[a])
				lengths[a] = tmp[a].size();
		
		lines.push_back(tmp);
	}
	
	unsigned ozipos = 1;
	for(unsigned a=0; a<lines.size(); ++a)
	{
		if(ozipos==a)
		{
			cout << nw;
        	for(unsigned c=0; c<lengths.size(); ++c)
        	{
        		if(c)cout << nm;
        		
        		for(unsigned b=0; b<lengths[c]; ++b)
        			cout << n;
        	}
        	cout << ne << endl;
		}

		const line &line = lines[a];
		cout << w;
		for(unsigned b=0; b<line.size(); ++b)
		{
			if(b)cout << m;
			
			cout << line[b];

			unsigned c = lengths[b] - line[b].size();
			while(c > 0) { --c; cout << ' '; }
		}
		//cout << e;
		cout << endl;
	}

	cout << sw;
	for(unsigned a=0; a<lengths.size(); ++a)
	{
		if(a)cout << sm;
		
		for(unsigned b=0; b<lengths[a]; ++b)
			cout << s;
	}
	cout << se << endl;
	return 0;
}
